## mingw-w64-tgui-1.10.0-1.src.tar.zst

=== CMakeLists.txt ===
####################################################################################################
# TGUI - Texus' Graphical User Interface
# Copyright (C) 2012-2025 Bruno Van de Velde (vdv_b@tgui.eu)
#
# This software is provided 'as-is', without any express or implied warranty.
# In no event will the authors be held liable for any damages arising from the use of this software.
#
# Permission is granted to anyone to use this software for any purpose,
# including commercial applications, and to alter it and redistribute it freely,
# subject to the following restrictions:
#
# 1. The origin of this software must not be misrepresented;
#    you must not claim that you wrote the original software.
#    If you use this software in a product, an acknowledgment
#    in the product documentation would be appreciated but is not required.
#
# 2. Altered source versions must be plainly marked as such,
#    and must not be misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
####################################################################################################

# If the cmake version is higher than the minimum version then enable all new policies, up to the maximum version specified.
# When cmake is newer than the highest version then its newest policies will still be set to the old behavior for compatibility.
cmake_minimum_required(VERSION 3.16...4.0)

# Include macros such as tgui_set_option
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Macros.cmake)

# Set a default build type
tgui_set_option(CMAKE_BUILD_TYPE Release STRING "Choose the type of build (Debug or Release)")

# Project name and version
project(TGUI VERSION 1.10.0 LANGUAGES CXX)

# Use the paths from the cmake GNUInstallDirs module as defaults (https://cmake.org/cmake/help/latest/module/GNUInstallDirs.html)
include(GNUInstallDirs)

# Include the configuration file which identifies the OS and compiler
include(${PROJECT_SOURCE_DIR}/cmake/Config.cmake)

if(TGUI_OS_IOS)
    # SFML 2 doesn't detect iOS in SFMLConfigDependencies.cmake when CMAKE_SYSTEM_NAME isn't "Darwin",
    # but luckily they don't have an error case so we just manually set the option about which OS was detected.
    # This hack is no longer needed for SFML 3.
    set(FIND_SFML_OS_IOS 1)
endif()

# Add the modules directory to find some of the dependencies
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/Modules")

# When building for Android, we install everything in $NDK/sources/third_party by default.
# The CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT variable is only TRUE on the first run,
# so this code needs to be before the backend selection (or any other code that can fail).
if(TGUI_OS_ANDROID AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_ANDROID_NDK}/sources/third_party/tgui CACHE PATH "Installation path (should be inside your NDK's 'sources' directory)" FORCE)
endif()

# Add an option for choosing the build type (shared or static).
# If TGUI_SHARED_LIBS is explicitly set then it overrules BUILD_SHARED_LIBS, otherwise honor the global setting.
if(NOT DEFINED TGUI_SHARED_LIBS)
    # Only create a cache variable for BUILD_SHARED_LIBS when TGUI is the top level project (or when CMake is too old to recognise it).
    # The cache entry is made to help people who build TGUI with the CMake GUI. Creating such a cache variable in a subproject could
    # lead to different behavior in the main project between first and subsequent CMake runs.
    if(NOT DEFINED BUILD_SHARED_LIBS AND (CMAKE_VERSION VERSION_LESS 3.21 OR PROJECT_IS_TOP_LEVEL))
        option(BUILD_SHARED_LIBS "ON to build a shared (dynamic) library, OFF to build a static library" ON)
    elseif(TGUI_OS_ANDROID AND NOT DEFINED BUILD_SHARED_LIBS)
        # For backwards compatiblity we will default to a shared library on Android without asking
        set(BUILD_SHARED_LIBS ON)
    endif()

    set(TGUI_SHARED_LIBS ${BUILD_SHARED_LIBS})
endif()

# Use c++17 by default on GCC >= 11, Clang >= 16 and IntelLLVM
if ((TGUI_COMPILER_GCC AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER_EQUAL "11")
 OR (TGUI_COMPILER_LLVM_CLANG AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER_EQUAL "16")
 OR TGUI_COMPILER_INTEL_ONEAPI)
    set(TGUI_DEFAULT_CXX_STANDARD "17")
else() # Use c++14 by default on all other compilers
    set(TGUI_DEFAULT_CXX_STANDARD "14")
endif()

tgui_set_option(TGUI_CXX_STANDARD ${TGUI_DEFAULT_CXX_STANDARD} STRING "C++ standard version to build TGUI with. Possible values: 14, 17, 20 or 23. Projects using TGUI must use a c++ version equal or higher to this")

# At least c++14 has to be used
if(TGUI_CXX_STANDARD LESS "14")
    message(FATAL_ERROR "TGUI_CXX_STANDARD has to be at least 14")
endif()

if(TGUI_BACKEND)
    set(backend_provided TRUE)
endif()

# Construct a list of supported backends based on the platform
set(TGUI_BACKEND_OPTIONS "")
set(TGUI_BACKEND_OPTIONS_DESC "")
if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS OR TGUI_OS_ANDROID OR TGUI_OS_IOS)
    list(APPEND TGUI_BACKEND_OPTIONS SFML_GRAPHICS)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - SFML_GRAPHICS: sfml-graphics\n")
endif()
if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS)
    list(APPEND TGUI_BACKEND_OPTIONS SFML_OPENGL3)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - SFML_OPENGL3: sfml-window + OpenGL + FreeType\n")
endif()
if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS OR TGUI_OS_ANDROID OR TGUI_OS_IOS)
    list(APPEND TGUI_BACKEND_OPTIONS SDL_GPU)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - SDL_GPU: SDL + SDL_ttf\n")
endif()
if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS OR TGUI_OS_ANDROID OR TGUI_OS_IOS)
    list(APPEND TGUI_BACKEND_OPTIONS SDL_RENDERER)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - SDL_RENDERER: SDL + SDL_ttf\n")
endif()
if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS)
    list(APPEND TGUI_BACKEND_OPTIONS SDL_OPENGL3)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - SDL_OPENGL3: SDL + OpenGL + FreeType\n")
endif()
if(TGUI_OS_LINUX)
    list(APPEND TGUI_BACKEND_OPTIONS SDL_GLES2)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - SDL_GLES2: SDL + OpenGL ES + FreeType\n")
endif()
if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS)
    list(APPEND TGUI_BACKEND_OPTIONS SDL_TTF_OPENGL3)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - SDL_TTF_OPENGL3: SDL + OpenGL + SDL_ttf\n")
endif()
if(TGUI_OS_LINUX OR TGUI_OS_ANDROID OR TGUI_OS_IOS)
    list(APPEND TGUI_BACKEND_OPTIONS SDL_TTF_GLES2)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - SDL_TTF_GLES2: SDL + OpenGL ES + SDL_ttf\n")
endif()
if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS)
    list(APPEND TGUI_BACKEND_OPTIONS GLFW_OPENGL3)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - GLFW_OPENGL3: GLFW + OpenGL + FreeType\n")
endif()
if(TGUI_OS_LINUX)
    list(APPEND TGUI_BACKEND_OPTIONS GLFW_GLES2)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - GLFW_GLES2: GLFW + OpenGL ES + FreeType\n")
endif()
if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS OR TGUI_OS_ANDROID)
    list(APPEND TGUI_BACKEND_OPTIONS RAYLIB)
    string(APPEND TGUI_BACKEND_OPTIONS_DESC " - RAYLIB: raylib\n")
endif()

tgui_set_option(TGUI_BACKEND SFML_GRAPHICS STRING "Select a backend for rendering or select Custom to use multiple or no backends")
set_property(CACHE TGUI_BACKEND PROPERTY STRINGS Custom;${TGUI_BACKEND_OPTIONS})

if(NOT backend_provided)
    message(FATAL_ERROR
      " Please select a backend by setting the value of TGUI_BACKEND.\n"
      " \n"
      " The following backends are available:\n"
      ${TGUI_BACKEND_OPTIONS_DESC}
      " \n"
      " SFML_GRAPHICS is the default and has been preselected, press configure again to continue with this backend.\n"
      " Select 'Custom' if you wish to build TGUI with multiple or no backends.\n")
endif()

string(TOUPPER "${TGUI_BACKEND}" TGUI_BACKEND_UPPERCASE)

# Add an option to build TGUI as a c++20 module (when using CMake >= 3.28)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.28)
    # We currently don't create the option as it is still too experimental,
    # it can still be used if the user manually specifies the option though.
    #option(TGUI_BUILD_AS_CXX_MODULE "ON to build TGUI as a c++20 module instead of using header files" OFF)
    #mark_as_advanced(TGUI_BUILD_AS_CXX_MODULE)
    if(TGUI_BUILD_AS_CXX_MODULE)
        if(TGUI_CXX_STANDARD LESS 20)
            message(FATAL_ERROR "TGUI_BUILD_AS_CXX_MODULE can only be turned on if TGUI_CXX_STANDARD is set to at least 20")
        endif()
        if(TGUI_OS_WINDOWS AND TGUI_SHARED_LIBS)
            message(FATAL_ERROR "On Windows, BUILD_SHARED_LIBS must be OFF if TGUI_BUILD_AS_CXX_MODULE is ON")
        endif()
    endif()
endif()

# Define an option for choosing between static and dynamic C runtime
if(TGUI_OS_WINDOWS)
    option(TGUI_USE_STATIC_STD_LIBS "TRUE to statically link to the standard libraries, FALSE to use the standard libraries as DLLs. This is NOT the option that you need to build TGUI statically, for that you just need to set TGUI_SHARED_LIBS to FALSE." FALSE)
    mark_as_advanced(TGUI_USE_STATIC_STD_LIBS)

    # Building TGUI as a dynamic library but linking statically to the standard library is not valid
    if(TGUI_SHARED_LIBS AND TGUI_USE_STATIC_STD_LIBS)
        message(FATAL_ERROR "TGUI_SHARED_LIBS and TGUI_USE_STATIC_STD_LIBS cannot be used together, you can only link statically to the standard library when TGUI is also build statically")
    endif()
endif()

if(TGUI_OS_WINDOWS AND TGUI_COMPILER_MSVC AND (CMAKE_GENERATOR MATCHES "Visual Studio"))
    option(TGUI_USE_MULTI_PROCESSOR_COMPILATION "Use /MP to speed up compilation of the TGUI library by using all cores" ON)
endif()

# Apple-specific options
if(TGUI_OS_MACOS OR TGUI_OS_IOS)

    # Add an option to build framework instead of dylib (release only)
    option(TGUI_BUILD_FRAMEWORK "TRUE to build TGUI as a framework library (release only), FALSE to build according to TGUI_SHARED_LIBS" ${TGUI_SHARED_LIBS})

    if (TGUI_OS_IOS AND TGUI_SHARED_LIBS AND NOT TGUI_BUILD_FRAMEWORK)
        message(FATAL_ERROR "Naked dynamic libs not supported for iOS, build static or frameworks instead")
    endif()

    if(TGUI_BUILD_FRAMEWORK)
        # Frameworks are only available for release (because cmake currently doesn't allow specifying a custom framework name so TGUI-d is not possible)
        if(NOT CMAKE_BUILD_TYPE STREQUAL "Release")
            message(FATAL_ERROR "CMAKE_BUILD_TYPE should be \"Release\" when TGUI_BUILD_FRAMEWORK is TRUE")
            return()
        endif()

        # Frameworks only work with TGUI_SHARED_LIBS enabled
        if(NOT TGUI_SHARED_LIBS)
            message(FATAL_ERROR "TGUI_SHARED_LIBS should be TRUE when TGUI_BUILD_FRAMEWORK is TRUE")
            return()
        endif()
    endif()
endif()

# Android-specific options
if(TGUI_OS_ANDROID)

    if(CMAKE_ANDROID_API LESS 19)
        message(FATAL_ERROR "Android API level (${CMAKE_ANDROID_API}) must be equal or greater than 19.")
    endif()

    # We install libs in a subdirectory named after the ABI (e.g. lib/armeabi/libtgui.so)
    set(CMAKE_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/${CMAKE_ANDROID_ARCH_ABI}")
endif()

# Add an option to choose whether PDB debug symbols should be generated for Visual Studio
if(TGUI_COMPILER_MSVC)
    option(TGUI_GENERATE_PDB "True to generate PDB debug symbols, FALSE otherwise." TRUE)
endif()

# Set the path for the libraries
set(LIBRARY_OUTPUT_PATH "${PROJECT_BINARY_DIR}/lib")

# Don't create an install target if we detect a dependency that is being build without an install target,
# of if TGUI is being built as a subdirectory.
if (NOT DEFINED TGUI_INSTALL)
    if ((CMAKE_VERSION VERSION_GREATER_EQUAL 3.21 AND NOT PROJECT_IS_TOP_LEVEL)
     OR (DEFINED SDL2_DISABLE_INSTALL AND SDL2_DISABLE_INSTALL)
     OR (DEFINED SDL_DISABLE_INSTALL AND SDL_DISABLE_INSTALL)
     OR (DEFINED SDL_INSTALL AND NOT SDL_INSTALL)

=== src/Backend/CMakeLists.txt ===
####################################################################################################
# TGUI - Texus' Graphical User Interface
# Copyright (C) 2012-2025 Bruno Van de Velde (vdv_b@tgui.eu)
#
# This software is provided 'as-is', without any express or implied warranty.
# In no event will the authors be held liable for any damages arising from the use of this software.
#
# Permission is granted to anyone to use this software for any purpose,
# including commercial applications, and to alter it and redistribute it freely,
# subject to the following restrictions:
#
# 1. The origin of this software must not be misrepresented;
#    you must not claim that you wrote the original software.
#    If you use this software in a product, an acknowledgment
#    in the product documentation would be appreciated but is not required.
#
# 2. Altered source versions must be plainly marked as such,
#    and must not be misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
####################################################################################################

if(TGUI_BACKEND_UPPERCASE STREQUAL "CUSTOM")
    if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS OR TGUI_OS_ANDROID OR TGUI_OS_IOS)
        tgui_set_option(TGUI_HAS_BACKEND_SFML_GRAPHICS FALSE BOOL "TRUE to build the SFML_GRAPHICS backend (uses sfml-graphics for everything)")
        tgui_set_option(TGUI_HAS_BACKEND_SDL_GPU FALSE BOOL "TRUE to build the SDL_RENDERER backend (SDL + SDL_ttf)")
        tgui_set_option(TGUI_HAS_BACKEND_SDL_RENDERER FALSE BOOL "TRUE to build the SDL_RENDERER backend (SDL + SDL_ttf)")
    endif()
    if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS OR TGUI_OS_ANDROID)
        tgui_set_option(TGUI_HAS_BACKEND_RAYLIB FALSE BOOL "TRUE to build the RAYLIB backend (uses raylib for everything)")
    endif()
    if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_ANDROID OR TGUI_OS_IOS)
        tgui_set_option(TGUI_HAS_BACKEND_SDL_GLES2 FALSE BOOL "TRUE to build the SDL_GLES2 backend (SDL + OpenGL ES + FreeType)")
        tgui_set_option(TGUI_HAS_BACKEND_SDL_TTF_GLES2 FALSE BOOL "TRUE to build the SDL_TTF_GLES2 backend (SDL + SDL_ttf + OpenGL ES)")
        tgui_set_option(TGUI_HAS_BACKEND_GLFW_GLES2 FALSE BOOL "TRUE to build the GLFW_GLES2 backend (GLFW + OpenGL ES + FreeType)")
    endif()
    if(TGUI_OS_WINDOWS OR TGUI_OS_LINUX OR TGUI_OS_MACOS)
        tgui_set_option(TGUI_HAS_BACKEND_SFML_OPENGL3 FALSE BOOL "TRUE to build the SFML_OPENGL3 backend (sfml-window + OpenGL + FreeType)")
        tgui_set_option(TGUI_HAS_BACKEND_SDL_OPENGL3 FALSE BOOL "TRUE to build the SDL_OPENGL3 backend (SDL + OpenGL + FreeType)")
        tgui_set_option(TGUI_HAS_BACKEND_SDL_TTF_OPENGL3 FALSE BOOL "TRUE to build the SDL_TTF_OPENGL3 backend (SDL + SDL_ttf + OpenGL)")
        tgui_set_option(TGUI_HAS_BACKEND_GLFW_OPENGL3 FALSE BOOL "TRUE to build the GLFW_OPENGL3 backend (GLFW + OpenGL + FreeType)")
    endif()

    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_WINDOW_SFML FALSE BOOL "TRUE to build the SFML window backend even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_WINDOW_SDL FALSE BOOL "TRUE to build the SDL window backend even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_WINDOW_GLFW FALSE BOOL "TRUE to build the GLFW window backend even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_WINDOW_RAYLIB FALSE BOOL "TRUE to build the raylib window backend even when not needed by any selected backend")

    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SFML_GRAPHICS FALSE BOOL "TRUE to build the sfml-graphics renderer even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_GPU FALSE BOOL "TRUE to build the SDL GPU renderer even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_RENDERER FALSE BOOL "TRUE to build the SDL_Renderer renderer even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_RENDERER_OPENGL3 FALSE BOOL "TRUE to build the modern OpenGL renderer even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_RENDERER_GLES2 FALSE BOOL "TRUE to build the OpenGL ES renderer even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_RENDERER_RAYLIB FALSE BOOL "TRUE to build the raylib renderer even when not needed by any selected backend")

    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_FONT_SFML_GRAPHICS FALSE BOOL "TRUE to build the sf::Font font loader even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_FONT_SDL_TTF FALSE BOOL "TRUE to build the SDL_ttf font loader even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_FONT_FREETYPE FALSE BOOL "TRUE to build the FreeType font loader even when not needed by any selected backend")
    tgui_set_option(TGUI_CUSTOM_BACKEND_HAS_FONT_RAYLIB FALSE BOOL "TRUE to build the raylib font loader even when not needed by any selected backend")

    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_WINDOW_SFML)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_WINDOW_SDL)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_WINDOW_GLFW)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_WINDOW_RAYLIB)

    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SFML_GRAPHICS)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_GPU)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_RENDERER)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_RENDERER_OPENGL3)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_RENDERER_GLES2)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_RENDERER_RAYLIB)

    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_FONT_SFML_GRAPHICS)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_FONT_SDL_TTF)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_FONT_FREETYPE)
    mark_as_advanced(TGUI_CUSTOM_BACKEND_HAS_FONT_RAYLIB)
else() # TGUI_BACKEND != Custom
    unset(TGUI_HAS_BACKEND_SFML_GRAPHICS CACHE)
    unset(TGUI_HAS_BACKEND_SFML_OPENGL3 CACHE)
    unset(TGUI_HAS_BACKEND_SDL_GPU CACHE)
    unset(TGUI_HAS_BACKEND_SDL_RENDERER CACHE)
    unset(TGUI_HAS_BACKEND_SDL_OPENGL3 CACHE)
    unset(TGUI_HAS_BACKEND_SDL_GLES2 CACHE)
    unset(TGUI_HAS_BACKEND_SDL_TTF_OPENGL3 CACHE)
    unset(TGUI_HAS_BACKEND_SDL_TTF_GLES2 CACHE)
    unset(TGUI_HAS_BACKEND_GLFW_OPENGL3 CACHE)
    unset(TGUI_HAS_BACKEND_GLFW_GLES2 CACHE)
    unset(TGUI_HAS_BACKEND_RAYLIB CACHE)

    unset(TGUI_CUSTOM_BACKEND_HAS_WINDOW_SFML CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_WINDOW_SDL CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_WINDOW_GLFW CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_WINDOW_RAYLIB CACHE)

    unset(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SFML_GRAPHICS CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_GPU CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_RENDERER CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_RENDERER_OPENGL3 CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_RENDERER_GLES2 CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_RENDERER_RAYLIB CACHE)

    unset(TGUI_CUSTOM_BACKEND_HAS_FONT_SFML_GRAPHICS CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_FONT_SDL_TTF CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_FONT_FREETYPE CACHE)
    unset(TGUI_CUSTOM_BACKEND_HAS_FONT_RAYLIB CACHE)

    if(NOT TGUI_BACKEND IN_LIST TGUI_BACKEND_OPTIONS)
        message(FATAL_ERROR "TGUI_BACKEND was set to an unknown backend")
    endif()

    if(TGUI_BACKEND STREQUAL "SFML_GRAPHICS")
        set(TGUI_HAS_BACKEND_SFML_GRAPHICS TRUE)
    elseif(TGUI_BACKEND STREQUAL "SFML_OPENGL3")
        set(TGUI_HAS_BACKEND_SFML_OPENGL3 TRUE)
    elseif(TGUI_BACKEND STREQUAL "SDL_GPU")
        set(TGUI_HAS_BACKEND_SDL_GPU TRUE)
    elseif(TGUI_BACKEND STREQUAL "SDL_RENDERER")
        set(TGUI_HAS_BACKEND_SDL_RENDERER TRUE)
    elseif(TGUI_BACKEND STREQUAL "SDL_OPENGL3")
        set(TGUI_HAS_BACKEND_SDL_OPENGL3 TRUE)
    elseif(TGUI_BACKEND STREQUAL "SDL_GLES2")
        set(TGUI_HAS_BACKEND_SDL_GLES2 TRUE)
    elseif(TGUI_BACKEND STREQUAL "SDL_TTF_OPENGL3")
        set(TGUI_HAS_BACKEND_SDL_TTF_OPENGL3 TRUE)
    elseif(TGUI_BACKEND STREQUAL "SDL_TTF_GLES2")
        set(TGUI_HAS_BACKEND_SDL_TTF_GLES2 TRUE)
    elseif(TGUI_BACKEND STREQUAL "GLFW_OPENGL3")
        set(TGUI_HAS_BACKEND_GLFW_OPENGL3 TRUE)
    elseif(TGUI_BACKEND STREQUAL "GLFW_GLES2")
        set(TGUI_HAS_BACKEND_GLFW_GLES2 TRUE)
    elseif(TGUI_BACKEND STREQUAL "RAYLIB")
        set(TGUI_HAS_BACKEND_RAYLIB TRUE)
    else()
        message(FATAL_ERROR "FIXME: Backend appeared in TGUI_BACKEND_OPTIONS but isn't being handled here!")
    endif()
endif()

# Figure out which backend components are needed
tgui_assign_bool(TGUI_HAS_WINDOW_BACKEND_SFML
    TGUI_HAS_BACKEND_SFML_GRAPHICS OR TGUI_HAS_BACKEND_SFML_OPENGL3 OR TGUI_CUSTOM_BACKEND_HAS_WINDOW_SFML)

tgui_assign_bool(TGUI_HAS_WINDOW_BACKEND_SDL
    TGUI_HAS_BACKEND_SDL_GPU OR TGUI_HAS_BACKEND_SDL_RENDERER OR TGUI_HAS_BACKEND_SDL_OPENGL3 OR TGUI_HAS_BACKEND_SDL_GLES2
    OR TGUI_HAS_BACKEND_SDL_TTF_OPENGL3 OR TGUI_HAS_BACKEND_SDL_TTF_GLES2
    OR TGUI_CUSTOM_BACKEND_HAS_WINDOW_SDL OR TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_GPU OR TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_RENDERER)

tgui_assign_bool(TGUI_HAS_WINDOW_BACKEND_GLFW
    TGUI_HAS_BACKEND_GLFW_OPENGL3 OR TGUI_HAS_BACKEND_GLFW_GLES2 OR TGUI_CUSTOM_BACKEND_HAS_WINDOW_GLFW)

tgui_assign_bool(TGUI_HAS_WINDOW_BACKEND_RAYLIB
    TGUI_HAS_BACKEND_RAYLIB OR TGUI_CUSTOM_BACKEND_HAS_WINDOW_RAYLIB)

tgui_assign_bool(TGUI_HAS_RENDERER_BACKEND_SFML_GRAPHICS
    TGUI_HAS_BACKEND_SFML_GRAPHICS OR TGUI_CUSTOM_BACKEND_HAS_RENDERER_SFML_GRAPHICS)

tgui_assign_bool(TGUI_HAS_RENDERER_BACKEND_SDL_GPU
    TGUI_HAS_BACKEND_SDL_GPU OR TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_GPU)

tgui_assign_bool(TGUI_HAS_RENDERER_BACKEND_SDL_RENDERER
    TGUI_HAS_BACKEND_SDL_RENDERER OR TGUI_CUSTOM_BACKEND_HAS_RENDERER_SDL_RENDERER)

tgui_assign_bool(TGUI_HAS_RENDERER_BACKEND_OPENGL3
    TGUI_HAS_BACKEND_SFML_OPENGL3 OR TGUI_HAS_BACKEND_SDL_OPENGL3 OR TGUI_HAS_BACKEND_SDL_TTF_OPENGL3
    OR TGUI_HAS_BACKEND_GLFW_OPENGL3 OR TGUI_CUSTOM_BACKEND_HAS_RENDERER_OPENGL3)

tgui_assign_bool(TGUI_HAS_RENDERER_BACKEND_GLES2
    TGUI_HAS_BACKEND_SDL_GLES2 OR TGUI_HAS_BACKEND_SDL_TTF_GLES2 OR TGUI_HAS_BACKEND_GLFW_GLES2 OR TGUI_CUSTOM_BACKEND_HAS_RENDERER_GLES2)

tgui_assign_bool(TGUI_HAS_RENDERER_BACKEND_RAYLIB
    TGUI_HAS_BACKEND_RAYLIB OR TGUI_CUSTOM_BACKEND_HAS_RENDERER_RAYLIB)

tgui_assign_bool(TGUI_HAS_FONT_BACKEND_SFML_GRAPHICS
    TGUI_HAS_BACKEND_SFML_GRAPHICS OR TGUI_CUSTOM_BACKEND_HAS_FONT_SFML_GRAPHICS)

tgui_assign_bool(TGUI_HAS_FONT_BACKEND_SDL_TTF
    TGUI_HAS_BACKEND_SDL_GPU OR TGUI_HAS_BACKEND_SDL_RENDERER OR TGUI_HAS_BACKEND_SDL_TTF_OPENGL3 OR TGUI_HAS_BACKEND_SDL_TTF_GLES2 OR TGUI_CUSTOM_BACKEND_HAS_FONT_SDL_TTF)

tgui_assign_bool(TGUI_HAS_FONT_BACKEND_FREETYPE
    TGUI_HAS_BACKEND_SFML_OPENGL3 OR TGUI_HAS_BACKEND_SDL_OPENGL3 OR TGUI_HAS_BACKEND_SDL_GLES2
    OR TGUI_HAS_BACKEND_GLFW_OPENGL3 OR TGUI_HAS_BACKEND_GLFW_GLES2 OR TGUI_CUSTOM_BACKEND_HAS_FONT_FREETYPE)

tgui_assign_bool(TGUI_HAS_FONT_BACKEND_RAYLIB
    TGUI_HAS_BACKEND_RAYLIB OR TGUI_CUSTOM_BACKEND_HAS_FONT_RAYLIB)

# Find and add dependencies
if(TGUI_HAS_RENDERER_BACKEND_SFML_GRAPHICS OR TGUI_HAS_FONT_BACKEND_SFML_GRAPHICS)
    tgui_add_dependency_sfml(Graphics)
elseif(TGUI_HAS_WINDOW_BACKEND_SFML)
    tgui_add_dependency_sfml(Window)
endif()
if(TGUI_HAS_WINDOW_BACKEND_SDL OR TGUI_HAS_FONT_BACKEND_SDL_TTF)
    tgui_add_dependency_sdl()
endif()
if(TGUI_HAS_WINDOW_BACKEND_GLFW)
    tgui_add_dependency_glfw()
endif()
if(TGUI_HAS_FONT_BACKEND_SDL_TTF)
    tgui_add_dependency_sdl_ttf()
endif()
if(TGUI_HAS_RENDERER_BACKEND_OPENGL3)
    tgui_add_dependency_opengl()
endif()
if(TGUI_HAS_RENDERER_BACKEND_GLES2)
    tgui_add_dependency_gles2()
endif()
if(TGUI_HAS_FONT_BACKEND_FREETYPE)
    tgui_add_dependency_freetype()

=== examples/android/SFML_GRAPHICS/app/src/main/jni/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)
project(tgui-example CXX)

set(sfml_version 3)  # Choose whether you want to use SFML 2 or SFML 3

set(SFML_DIR "${CMAKE_ANDROID_NDK}/sources/third_party/sfml/lib/${CMAKE_ANDROID_ARCH_ABI}/cmake/SFML")
set(TGUI_DIR "${CMAKE_ANDROID_NDK}/sources/third_party/tgui/lib/${CMAKE_ANDROID_ARCH_ABI}/cmake/TGUI")

# Create the libapp.so library that contains the application's c++ code
add_library(app SHARED)

# Find and link the dependencies
if (sfml_version EQUAL 3)
    target_sources(app PRIVATE main-sfml3.cpp)

    find_package(SFML 3 REQUIRED COMPONENTS Graphics Main CONFIG)
    target_link_libraries(app PRIVATE SFML::Graphics)

    target_link_libraries(app PUBLIC
      -Wl,--whole-archive
      SFML::Main
      -Wl,--no-whole-archive
    )
else()
    target_sources(app PRIVATE main-sfml2.cpp)

    find_package(SFML 2 REQUIRED COMPONENTS graphics window system CONFIG)
    target_link_libraries(app PRIVATE sfml-graphics sfml-window sfml-system)

    target_link_libraries(app PUBLIC
      -Wl,--whole-archive
      sfml-main
      -Wl,--no-whole-archive
    )
endif()

find_package(TGUI 1 REQUIRED CONFIG)
target_link_libraries(app PRIVATE TGUI::TGUI android log)

=== examples/android/RAYLIB/app/src/main/cpp/deps/raylib/CMakeLists.txt ===
# Define a library for raylib
add_library(raylib STATIC
    rcore.c
    rmodels.c
    rshapes.c
    rtext.c
    rtextures.c
    raudio.c
    utils.c
    )

# Include headers directory for android_native_app_glue.c
include_directories(${ANDROID_NDK}/sources/android/native_app_glue/)

# Add android_native_app_glue.c to the source files
list(APPEND SOURCES ${ANDROID_NDK}/sources/android/native_app_glue/android_native_app_glue.c)

# Define compiler macros for raylib
target_compile_definitions(raylib PUBLIC PLATFORM_ANDROID __ANDROID__)

# Add specific compilation options based on target Android architecture
if(CMAKE_ANDROID_ARCH_ABI STREQUAL "armeabi-v7a")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfloat-abi=softfp -mfpu=vfpv3-d16")
elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "arm64-v8a")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfix-cortex-a53-835769")
endif()

# Link required libraries to raylib
target_link_libraries(raylib log android EGL OpenSLES dl m c)

# Additional configuration depending on the desired OpenGL version
if(GL_VERSION STREQUAL "ES20")
    target_compile_definitions(raylib PUBLIC GRAPHICS_API_OPENGL_ES2)
    target_link_libraries(raylib GLESv2)
elseif(GL_VERSION STREQUAL "ES30" OR GL_VERSION STREQUAL "ES31" OR GL_VERSION STREQUAL "ES32")
    target_compile_definitions(raylib PUBLIC GRAPHICS_API_OPENGL_ES3)
    target_link_libraries(raylib GLESv3)
endif()

# Add library-specific binding option
target_link_options(raylib PRIVATE "-u ANativeActivity_onCreate")

=== examples/android/RAYLIB/app/src/main/cpp/deps/raymob/CMakeLists.txt ===
# Define a library for raymoblib
add_library(raymoblib STATIC helper.c sensor.c vibrator.c display.c soft_keyboard.c callback.c)

# Include headers directory for android_native_app_glue.c
include_directories(${ANDROID_NDK}/sources/android/native_app_glue/)

# Add android_native_app_glue.c to the source files
list(APPEND SOURCES ${ANDROID_NDK}/sources/android/native_app_glue/android_native_app_glue.c)

# Define compiler macros for the library
target_compile_definitions(raymoblib PRIVATE PLATFORM_ANDROID)

# Include raylib header files
target_include_directories(raymoblib PRIVATE "${CMAKE_SOURCE_DIR}/deps/raylib")

# Link required libraries to raylib
target_link_libraries(raymoblib raylib)

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=tgui
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.10.0
pkgrel=1
pkgdesc="Cross-platform C++ GUI library (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://tgui.eu/'
msys2_repository_url='https://github.com/texus/TGUI'
license=('spdx:Zlib')
depends=("${MINGW_PACKAGE_PREFIX}-sdl3"
         "${MINGW_PACKAGE_PREFIX}-sdl3-ttf")
makedepends=("${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-doxygen")

source=("${msys2_repository_url}/archive/v${pkgver}/${_realname^^}-${pkgver}.tar.gz")
sha256sums=('b25a5f8aca7823314e268118015aa14a8eb65956e09f447010230df10dc560b0')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  # static build
  mkdir -p "${srcdir}"/build-${MSYSTEM}-static && cd "${srcdir}"/build-${MSYSTEM}-static
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ${extra_config} \
    -DTGUI_SHARED_LIBS=OFF \
    -DTGUI_BACKEND=SDL_RENDERER \
    -DTGUI_USE_SDL3=ON \
    ../${_realname^^}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .

  # shared build
  mkdir -p "${srcdir}"/build-${MSYSTEM}-shared && cd "${srcdir}"/build-${MSYSTEM}-shared
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ${extra_config} \
    -DTGUI_SHARED_LIBS=ON \
    -DTGUI_BUILD_DOC=ON \
    -DTGUI_BACKEND=SDL_RENDERER \
    -DTGUI_USE_SDL3=ON \
    ../${_realname^^}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  # Static Install
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  # Shared Install
  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}/${_realname^^}-${pkgver}/license.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/license.txt"
}
